=== debian/changelog ===
libpoly0 (1.8-0ubuntu1) bionic; urgency=medium

  * Initial release. (Closes: #864834)

 -- Ian A. Mason <iam@csl.sri.com>  Thu, 10 Aug 2017 13:46:30 +0000
